#include"EntierInfini.h"

struct  EntierInfini{
	char  signe;
	char* valeur;
	};

char * obtenirValeurEntierInfini(EntierInfini e){
  return e->valeur;
}


void verifierSigneEntierInfini(EntierInfini e){
  if (strcmp(e->valeur,"0")==0)
    e->signe='+';
}


/* fonction de traitement de chaine qui enleve les zeros en tete
   "00025" --> "25" */
char * enleverLesZerosEnTete(char * chaine){
  int indice,i,compteur,longueur;
  char * resultat;
  indice = 0;
  /* parcours de la chaine pour les zros */
  while (chaine[indice] =='0')
    indice++;

  /* reglage pour recopie */

  if (indice==strlen(chaine)){
    resultat=(char *) calloc(2,sizeof(char));
    resultat[1]='\0';
    resultat[0]='0';
    return resultat;
  }
  else{
    longueur = strlen(chaine)-indice;
    resultat = (char *) calloc(longueur+1,sizeof(char));
    resultat[longueur] = '\0';

  /* initialisation compteur de boucle */
    compteur = 0;

  /* recopie de la chaine sans les 0 */
    for(i=indice;i<strlen(chaine);i++){
      resultat[compteur] = chaine[i];
      compteur++;
    }


    return resultat;
  }
}



/* fonction d'allocation d'espace pour un entier Infini */
EntierInfini reserverEspacePourEntierInfini(){
  return (malloc(sizeof(struct EntierInfini)));
}


/* fonction de cration d'un entier Infini */
EntierInfini creerUnEntierInfiniAPartirDe(char* chaine,char signe){
  EntierInfini e=reserverEspacePourEntierInfini();
  e->valeur=(char *) calloc(strlen(chaine),sizeof(char));
  strcpy(e->valeur,chaine);
  e->signe=signe;
  return e;
}

//Conversion d'un EntierInfini vers un ReelInfini
ReelInfini convertirUnEntierInfiniVersUnReelInfini(EntierInfini e){
  char* zero;
  printf("EntierInfini.c : On convertit un EntierInfini vers une ReelInfini\n");
  *zero = 0;
  return creerUnReelInfiniAPartirDe(e->valeur,zero,e->signe);
  printf("EntierInfini.c : On a fini de convertir\n"); 
  libererEntierInfini (e);
}

/* destructeur d'un Entier Infini */
void libererEntierInfini(EntierInfini pe){
	free(pe->valeur);
	free(pe);
}



/* multiplier les signes d'entier Infini */
char multiplierLesSignesDeDeuxEntiersInfinis(EntierInfini e1, EntierInfini e2){
	if(e1->signe==e2->signe) return '+';
	else return '-';
}



/* affichage d'un entier Infini */
char* afficherUnEntierInfiniAPartirDe(EntierInfini e){
	char * temp;
	if(e->signe=='+'){
	  temp = (char *) calloc(strlen(e->valeur)+1,sizeof(char));
	  strcpy(temp,e->valeur);
	}
	else{
	  temp = (char *) calloc(strlen(e->valeur)+2,sizeof(char));
	  temp[0] = '-';
	  strcpy(temp+1,e->valeur);
	}
	return temp;
}



/* fonction de somme de deux chaine de caractres */
char * additionnerDeuxPartiesEntieres(char * chaine1, char * chaine2){
  char * resultat;
  int longueur,nb1,nb2,nbresult,reste,deb1,deb2,indice;
  longueur = strlen(chaine1)+strlen(chaine2);
  resultat = (char *) calloc(longueur+1,sizeof(char));
  resultat[longueur] = '\0';

  /* initialisation des indices de parcours de boucle */
  deb1 = strlen(chaine1) - 1;
  deb2 = strlen(chaine2) - 1;
  reste = 0;

  /* dbut boucle de calcul de l'addition */
  for(indice=longueur-1;indice>=0;indice--){
    if (deb1 < 0)
      nb1 = 0;
    else{
      if (chaine1[deb1]<0x30)
	deb1--;
      nb1 = (int) (chaine1[deb1]-0x30);
      deb1--;
    }

    if (deb2 < 0)
      nb2 = 0;
    else{
      if (chaine2[deb2]<0x30)
	deb2--;
      nb2 = (int) (chaine2[deb2]-0x30);
      deb2--;
    }

    nbresult = nb1 + nb2 + reste;
    reste = nbresult / 10;
    resultat[indice] =(char) ((nbresult % 10)+0x30);

  }
  return resultat;
}


/* soustraction des parties Entieres */
char * soustraireDeuxPartiesEntieres(char * chaine1,char * chaine2){
  char * resultat;
  int longueur,nb1,nb2,nbresult,reste,deb1,deb2,indice;
  longueur = strlen(chaine1);
  resultat = (char *) calloc(longueur+1,sizeof(char));
  resultat[longueur] = '\0';

  /* initialisation des indices de parcours de boucle */
  deb1 = strlen(chaine1) - 1;
  deb2 = strlen(chaine2) - 1;
  reste = 0;

  /* dbut boucle de calcul de l'addition */
  for(indice=longueur-1;indice>=0;indice--){
    if (deb1 < 0)
      nb1 = 0;
    else{
      if (chaine1[deb1]<0x30)
	deb1--;
      nb1 = (int) (chaine1[deb1]-0x30);
      deb1--;
    }

    if (deb2 < 0)
      nb2 = 0;
    else{
      if (chaine2[deb2]<0x30)
	deb2--;
      nb2 = (int) (chaine2[deb2]-0x30);
      deb2--;
    }

    nbresult = nb1 - nb2 - reste;
    if (nbresult < 0){
      nbresult = nbresult + 10;
      reste = 1;
    }
    else
      reste = 0;
    resultat[indice] =(char) ((nbresult % 10)+0x30);

  }
  return resultat;
}


/* multiplication d'une chaine de caractre reprsentant un nombre,
   par un chiffre */
char * multiplierPartieEntiereParChiffre(char * chaine,int e){
  char * resultat;
  long longueur,indicef,indice,reste,x,result;
  longueur = strlen(chaine)+1;
  resultat = (char *) calloc(longueur+1,sizeof(char));
  reste = 0;
  indice =  longueur - 2;
  for(indicef=longueur-1;indicef>=0;indicef--){
    if (indice < 0)
      x = 0;
    else
      x = (long) (chaine[indice]-0x30);
    result = x*e+reste;
    reste = result / 10;
    resultat[indicef] = (char) ((result % 10)+0x30);
    indice = indice -1;
  }
  return resultat;
}


/* fonction de traitement de chaine qui rajoute e '0'  la fin
   de la chaine */
char * multiplierParPuissanceDeDix(char * chaine,int e){
  char * resultat;
  long longueur,indice,longueurchaine;
  longueur = strlen(chaine)+e;
  longueurchaine = strlen(chaine);
  resultat = (char *) calloc(longueur+1,sizeof(char));
  resultat[longueur]='\0';
  for (indice=0;indice<longueur;indice++){
    if (indice >= longueurchaine)
      resultat[indice]='0';
    else
      resultat[indice]=chaine[indice];
  }
  return resultat;
}


/* fonction de multiplication de deux chaines de caractres */
char * multiplierDeuxPartiesEntieres(char * chaine1,char* chaine2){
  char * final;
  char * temp;
  char * somme;
  long longueur,indice,n,nbiterations;
  longueur = strlen(chaine1) + strlen(chaine2);
  final = (char *) calloc(longueur+1,sizeof(char));
  final[longueur]='\0';
  nbiterations=strlen(chaine1);
  for(indice=0;indice<longueur;indice++)
    final[indice]='0';
  for(indice=1;indice<=nbiterations;indice++){
    n = (long) (chaine1[nbiterations-indice]-0x30);
    somme = multiplierPartieEntiereParChiffre(chaine2,n);
    temp = multiplierParPuissanceDeDix(somme,indice-1);
    free(somme);
    somme = temp;
    temp = additionnerDeuxPartiesEntieres(somme,final);
    free(somme);
    final = enleverLesZerosEnTete(temp);
    free(temp);
  }
  temp = enleverLesZerosEnTete(final);
  free(final);
  return temp;
}



/* fonction de comparaison d'EntierInfini */
/*int estUnEntierInfiniSuperieurAUnEntierInfini(EntierInfini e1,EntierInfini e2){
  int N1,N2,N,i,chiffreDeChaine1,chiffreDeChaine2;
  int resultat;
  resultat=1;
  if((e1->signe=='-') && (e2->signe=='+')){
    resultat=0;
  }
  else{}
  if((e1->signe=='+') && (e2->signe=='-')) {
    resultat=1;
  }
  else {}
  if (((e1->signe=='+') && (e2->signe=='+'))|| ((e1->signe=='-') && (e2->signe=='-'))){
    N1=strlen(e1->valeur);
    N2=strlen(e2->valeur);
    if(N1>N2) {N=N1;}
    else {N=N2;}
    i=0;
    while (i<=N-1){
      chiffreDeChaine1=(int)(e1->valeur[i]);
      chiffreDeChaine2=(int)(e2->valeur[i]);
      if (chiffreDeChaine1==chiffreDeChaine2){
	i=i+1;
      }
      else{
	if (chiffreDeChaine1>chiffreDeChaine2){
	  i=N;
	  if ((e1->signe=='+') && (e2->signe=='+')){
	    resultat=1;
	  }
	  else{
	    resultat=0;
	  }
	}
	else{
	  i=N;
	  if ((e1->signe=='+') && (e2->signe=='+')){
	    resultat=0;
	  }
	  else{
	    resultat=1;
	  }
	}
      }
    }
  }
  return resultat;
}
*/


EntierInfini additionnerDeuxEntiersInfinis(EntierInfini e1,EntierInfini e2){
  EntierInfini resultat,e1prime,e2prime;
  char * temp;
  resultat = reserverEspacePourEntierInfini();
  if (multiplierLesSignesDeDeuxEntiersInfinis(e1,e2)=='+'){
    resultat->valeur = additionnerDeuxPartiesEntieres(e1->valeur,e2->valeur);
    resultat->signe=e1->signe;
  }
  else{

  /* dtermination du signe */
  /* on cre alors 2 entier Infini qui seront les valeurs absolue des deux
     autrs et on les compare */

    e1prime = creerUnEntierInfiniAPartirDe(e1->valeur,'+');
    e2prime = creerUnEntierInfiniAPartirDe(e2->valeur,'+');

    if (estUnEntierInfiniSuperieurAUnEntierInfini(e1prime,e2prime)){
      resultat->signe = e1->signe;
      resultat->valeur = soustraireDeuxPartiesEntieres(e1->valeur,e2->valeur);
    }
    else{
      resultat->signe = e2->signe;
      resultat->valeur = soustraireDeuxPartiesEntieres(e2->valeur,e1->valeur);
    }

    libererEntierInfini(e1prime);
    libererEntierInfini(e2prime);
  }

  temp = resultat->valeur;

  resultat->valeur = enleverLesZerosEnTete(temp);
  free(temp);

  verifierSigneEntierInfini(resultat);

  return resultat;
}



/* fonction de soustraction de deux Entiers Infinis */
EntierInfini soustraireDeuxEntiersInfinis(EntierInfini e1,EntierInfini e2){
  EntierInfini resultat,e1prime,e2prime;
  char * temp;
  int changesigne;

  resultat = reserverEspacePourEntierInfini();

  changesigne=0;
  e1prime = creerUnEntierInfiniAPartirDe(e1->valeur,'+');
  e2prime = creerUnEntierInfiniAPartirDe(e2->valeur,'+');

  if (multiplierLesSignesDeDeuxEntiersInfinis(e1,e2)=='-'){
    resultat->valeur = additionnerDeuxPartiesEntieres(e1->valeur,e2->valeur);
  }

  else{

    if (estUnEntierInfiniSuperieurAUnEntierInfini(e1prime,e2prime)){
      resultat->valeur = soustraireDeuxPartiesEntieres(e1->valeur,e2->valeur);
    }
    else{
      changesigne=1;
      resultat->valeur = soustraireDeuxPartiesEntieres(e2->valeur,e1->valeur);
    }
  }

  /* dtermination du signe */
  /* dans le cas des signes contraires, le signe est forcment celui
     dont la valeur absolue est la plus forte.
     sinon, cela dpend de l'ordre de la soustraction */

  if (estUnEntierInfiniSuperieurAUnEntierInfini(e1prime,e2prime))
    // |e1| > |e2|
    resultat->signe=e1->signe;
  else
    resultat->signe=e2->signe;

  // toutefois selon l'ordre le signe change

  if (changesigne){
    if (resultat->signe=='+')
      resultat->signe='-';
    else
      resultat->signe='+';
  }

  temp = resultat->valeur;

  resultat->valeur = enleverLesZerosEnTete(temp);
  free(temp);

  verifierSigneEntierInfini(resultat);

  libererEntierInfini(e1prime);
  libererEntierInfini(e2prime);

  return resultat;
}


/* fonction de multiplication de deux parties Entieres */
EntierInfini multiplierDeuxEntiersInfinis(EntierInfini e1,EntierInfini e2){
  EntierInfini resultat;
 resultat = reserverEspacePourEntierInfini();
  if (multiplierLesSignesDeDeuxEntiersInfinis(e1,e2)=='+')
    resultat->signe = '+';
  else
    resultat->signe = '-';
  resultat->valeur = multiplierDeuxPartiesEntieres(e1->valeur,e2->valeur);
  verifierSigneEntierInfini(resultat);
  return resultat;
}

EntierInfini obtenirValeurAbsolueDeLEntierInfini(EntierInfini e){
	if(e->signe=='+') return e;
	else return creerUnEntierInfiniAPartirDe(e->valeur,'+');
}
EntierInfini diviserDeuxEntiersInfinis(EntierInfini e1, EntierInfini e2){
	EntierInfini un, temp, resultat, valeurAbsolueDeE1, valeurAbsolueDeE2;
	un=creerUnEntierInfiniAPartirDe("1",'+');

	valeurAbsolueDeE1=creerUnEntierInfiniAPartirDe(e1->valeur,'+');
	valeurAbsolueDeE2=creerUnEntierInfiniAPartirDe(e2->valeur,'+');
	temp=creerUnEntierInfiniAPartirDe(e2->valeur,'+');

	resultat=creerUnEntierInfiniAPartirDe("0",'+');

	//On effectue le calcul de |e1| div |e2|
	while(estUnEntierInfiniInferieurAUnEntierInfini(temp,valeurAbsolueDeE1)==1){
		resultat=additionnerDeuxEntiersInfinis(resultat,un);
		temp=additionnerDeuxEntiersInfinis(temp,valeurAbsolueDeE2);
	}

	// On affecte le bon signe  la variable resultat
	if(resultat->valeur!="0") resultat->signe=multiplierLesSignesDeDeuxEntiersInfinis(e1,e2);

	libererEntierInfini(un);
	libererEntierInfini(temp);
	libererEntierInfini(valeurAbsolueDeE1);
	libererEntierInfini(valeurAbsolueDeE2);
	return resultat;
}

EntierInfini calculerLeResteDeLaDivisionDeDeuxEntiersInfinis(EntierInfini e1, EntierInfini e2){
	EntierInfini div;
	div=reserverEspacePourEntierInfini();
	div=diviserDeuxEntiersInfinis(e1,e2);
	return soustraireDeuxEntiersInfinis(e1,multiplierDeuxEntiersInfinis(div,e2));
}

EntierInfini calculerFactorielleDe(EntierInfini e){
	EntierInfini un, deux, resultat;
	un=creerUnEntierInfiniAPartirDe("1",'+');
	deux=creerUnEntierInfiniAPartirDe("2",'+');
	resultat=creerUnEntierInfiniAPartirDe("1",'+');

	while(estUnEntierInfiniSuperieurAUnEntierInfini(e,deux)==1){
		resultat=multiplierDeuxEntiersInfinis(resultat,e);
		e=soustraireDeuxEntiersInfinis(e,un);
	}

	libererEntierInfini(un);
	libererEntierInfini(deux);
	return resultat;
}


EntierInfini calculerArrangementDe(EntierInfini e1, EntierInfini e2){
	if(estUnEntierInfiniStrictementInferieurAUnEntierInfini(e1,e2)==1) return creerUnEntierInfiniAPartirDe("0",'+');
	else return diviserDeuxEntiersInfinis(calculerFactorielleDe(e1), calculerFactorielleDe(soustraireDeuxEntiersInfinis(e1,e2)));
}

EntierInfini calculerCombinaisonDe(EntierInfini e1, EntierInfini e2){
	EntierInfini un, e1_1, e2_1;
	un=creerUnEntierInfiniAPartirDe("1",'+');

	if(estUnEntierInfiniStrictementInferieurAUnEntierInfini(e1,e2)==1) return creerUnEntierInfiniAPartirDe("0",'+');
	else{
		if((sontDeuxEntiersInfinisEgaux(e2,un)==1)||(sontDeuxEntiersInfinisEgaux(e1,additionnerDeuxEntiersInfinis(e2,un))==1)){
			libererEntierInfini(un);
			return e1;
		}
		else if((sontDeuxEntiersInfinisEgaux(e1,e2)==1)||(sontDeuxEntiersInfinisEgaux(e2,creerUnEntierInfiniAPartirDe("0",'+'))==1)){
			libererEntierInfini(un);
			return un;
		}
		else{
			e1_1=soustraireDeuxEntiersInfinis(e1,un);
			e2_1=soustraireDeuxEntiersInfinis(e2,un);
			return additionnerDeuxEntiersInfinis(calculerCombinaisonDe(e1_1,e2),calculerCombinaisonDe(e1_1,e2_1));
			libererEntierInfini(un);
			libererEntierInfini(e1_1);
			libererEntierInfini(e2_1);
		}
	}
}

int sontDeuxEntiersInfinisEgaux(EntierInfini e1,EntierInfini e2){
	int N1,N2,i,chiffreDeChaine1,chiffreDeChaine2;
	int resultat;
	resultat=1;
	if(e1->signe!=e2->signe) resultat=0;
	else {
		N1=strlen(e1->valeur);
		N2=strlen(e2->valeur);
		i=0;
		if(N1!=N2){
					resultat=0;}
		else {
				while(i<=(N1)-1){
								chiffreDeChaine1=(int)(e1->valeur[i]);
								chiffreDeChaine2=(int)(e2->valeur[i]);
								if (chiffreDeChaine1==chiffreDeChaine2)
								{i=i+1;}
								else {
										i=N1;
										resultat=0;}
								}
				}
		}
	return resultat;
}

int estUnEntierInfiniInferieurAUnEntierInfini(EntierInfini e1,EntierInfini e2){
	int N1,N2,N,i,chiffreDeChaine1,chiffreDeChaine2;
	int resultat;
	resultat=1;
	if((e1->signe=='-') && (e2->signe=='+')){
		resultat=1;
	}
	else{}
	if((e1->signe=='+') && (e2->signe=='-')) {
		resultat=0;
	}
	else {}
	if (((e1->signe=='+') && (e2->signe=='+'))|| ((e1->signe=='-') && (e2->signe=='-'))){
		N1=strlen(e1->valeur);
		N2=strlen(e2->valeur);
		if(N1>N2) {N=N1;}
		else {N=N2;}
		i=0;
		if (N1>N2){
		while (i<=N-1){
			chiffreDeChaine1=(int)(e1->valeur[i]);
			chiffreDeChaine2=(int)(e2->valeur[i+(N1-N2)]);
			if (chiffreDeChaine1==chiffreDeChaine2){
				i=i+1;
			}
			else{
				if (chiffreDeChaine1<chiffreDeChaine2){
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=1;
					}
					else{
						resultat=0;
					}
				}
				else{
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=0;
					}
					else{
						resultat=1;
					}
				}
			}
		}}
		if(N1==N2){while (i<=N-1){
			chiffreDeChaine1=(int)(e1->valeur[i]);
			chiffreDeChaine2=(int)(e2->valeur[i]);
			if (chiffreDeChaine1==chiffreDeChaine2){
				i=i+1;
			}
			else{
				if (chiffreDeChaine1<chiffreDeChaine2){
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=1;
					}
					else{
						resultat=0;
					}
				}
				else{
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=0;
					}
					else{
						resultat=1;
					}
				}
			}
		}}
		if(N2>N1){
		  if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=1;
					}
					else{
						resultat=0;
					}

		}}
return resultat;
}

int estUnEntierInfiniStrictementInferieurAUnEntierInfini(EntierInfini e1,EntierInfini e2){
	int N1,N2,N,i,chiffreDeChaine1,chiffreDeChaine2;
	int resultat;
	resultat=0;
	if((e1->signe=='-') && (e2->signe=='+')){
		resultat=1;
	}
	else{}
	if((e1->signe=='+') && (e2->signe=='-')) {
		resultat=0;
	}
	else {}
	if (((e1->signe=='+') && (e2->signe=='+'))|| ((e1->signe=='-') && (e2->signe=='-'))){
		N1=strlen(e1->valeur);
		N2=strlen(e2->valeur);
		if(N1>N2) {N=N1;}
		else {N=N2;}
		i=0;
		if(N1>N2){
		while (i<=N-1){
			chiffreDeChaine1=(int)(e1->valeur[i]);
			chiffreDeChaine2=(int)(e2->valeur[i+(N1-N2)]);
			if (chiffreDeChaine1==chiffreDeChaine2){
				i=i+1;
			}
			else{
				if (chiffreDeChaine1<chiffreDeChaine2){
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=1;
					}
					else{
						resultat=0;
					}
				}
				else{
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=0;
					}
					else{
						resultat=1;
					}
				}
			}
		}}
		if(N1==N2){while (i<=N-1){
			chiffreDeChaine1=(int)(e1->valeur[i]);
			chiffreDeChaine2=(int)(e2->valeur[i]);
			if (chiffreDeChaine1==chiffreDeChaine2){
				i=i+1;
			}
			else{
				if (chiffreDeChaine1<chiffreDeChaine2){
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=1;
					}
					else{
						resultat=0;
					}
				}
				else{
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=0;
					}
					else{
						resultat=1;
					}
				}
			}
		}}
		if(N2>N1){if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=1;
					}
					else{
						resultat=0;
					}

		}
	}
return resultat;
}

int estUnEntierInfiniSuperieurAUnEntierInfini(EntierInfini e1,EntierInfini e2){
	int N1,N2,N,i,chiffreDeChaine1,chiffreDeChaine2;
	int resultat;
	resultat=1;
	if((e1->signe=='-') && (e2->signe=='+')){
		resultat=0;
	}
	else{}
	if((e1->signe=='+') && (e2->signe=='-')) {
		resultat=1;
	}
	else {}
	if (((e1->signe=='+') && (e2->signe=='+'))|| ((e1->signe=='-') && (e2->signe=='-'))){
		N1=strlen(e1->valeur);
		N2=strlen(e2->valeur);
		if(N1>N2) {N=N1;}
		else {N=N2;}
		i=0;
		if(N1>N2)
		while (i<=N-1){
			chiffreDeChaine1=(int)(e1->valeur[i]);
			chiffreDeChaine2=(int)(e2->valeur[i+(N1-N2)]);
			if (chiffreDeChaine1==chiffreDeChaine2){
				i=i+1;
			}
			else{
				if (chiffreDeChaine1>chiffreDeChaine2){
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=1;
					}
					else{
						resultat=0;
					}
				}
				else{
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=0;
					}
					else{
						resultat=1;
					}
				}
			}
		}}
	if(N1==N2){while (i<=N-1){
			chiffreDeChaine1=(int)(e1->valeur[i]);
			chiffreDeChaine2=(int)(e2->valeur[i]);
			if (chiffreDeChaine1==chiffreDeChaine2){
				i=i+1;
			}
			else{
				if (chiffreDeChaine1>chiffreDeChaine2){
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=1;
					}
					else{
						resultat=0;
					}
				}
				else{
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=0;
					}
					else{
						resultat=1;
					}
				}
			}
	}}
	if(N2>N1){if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=0;
					}
					else{
						resultat=1;
					}

	}
return resultat;
}


int estUnEntierInfiniStrictementSuperieurAUnEntierInfini(EntierInfini e1,EntierInfini e2){
	int N1,N2,N,i,chiffreDeChaine1,chiffreDeChaine2;
	int resultat;
	resultat=0;
	if((e1->signe=='-') && (e2->signe=='+')){
		resultat=0;
	}
	else{}
	if((e1->signe=='+') && (e2->signe=='-')) {
		resultat=1;
	}
	else {}
	if (((e1->signe=='+') && (e2->signe=='+'))|| ((e1->signe=='-') && (e2->signe=='-'))){
		N1=strlen(e1->valeur);
		N2=strlen(e2->valeur);
		if(N1>N2) {N=N1;}
		else {N=N2;}
		i=0;
		while (i<=N-1){
			chiffreDeChaine1=(int)(e1->valeur[i]);
			chiffreDeChaine2=(int)(e2->valeur[i]);
			if (chiffreDeChaine1==chiffreDeChaine2){
				i=i+1;
			}
			else{
				if (chiffreDeChaine1>chiffreDeChaine2){
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=1;
					}
					else{
						resultat=0;
					}
				}
				else{
					i=N;
					if ((e1->signe=='+') && (e2->signe=='+')){
						resultat=0;
					}
					else{
						resultat=1;
					}
				}
			}
		}

	}
return resultat;
}

// retourne un EntierInfini qui est l'oppose de e
EntierInfini prendreOpposeDUnEntierInfini(EntierInfini e) {
  if ( e->signe == '+' ) e->signe = '-';
  else e->signe = '+';
  return e;
}
