# ifndef ENTIER_INFINI_H

	# define ENTIER_INFINI_H
	typedef struct EntierInfini* EntierInfini;
	#include "ReelInfini.h"
        #include <stdio.h>
        #include <stdlib.h>
        #include <unistd.h>
        #include <string.h>
 
	EntierInfini creerUnEntierInfiniAPartirDe(char* chaine,char signe);
	// retourne un EntierInfini  partir de l'argument chane de caractres chaine
	// et dont le signe est spcifi par le caractre signe o signe={'+';'-'}

        ReelInfini convertirUnEntierInfiniVersUnReelInfini(EntierInfini e);
        //Conversion d'un EntierInfini vers un ReelInfini

	EntierInfini additionnerDeuxEntiersInfinis(EntierInfini e1,EntierInfini e2);
	// retourne un EntierInfini qui est le rsultat de e1+e2

	EntierInfini soustraireDeuxEntiersInfinis(EntierInfini e1,EntierInfini e2);
	// retourne un EntierInfini qui est le rsultat de e1-e2 

        EntierInfini prendreOpposeDUnEntierInfini(EntierInfini e);
	// retourne un EntierInfini qui est l'oppose de e 

	EntierInfini multiplierDeuxEntiersInfinis(EntierInfini e1,EntierInfini e2);
	// retourne un EntierInfini qui est le rsultat de e1*e2 

	EntierInfini diviserDeuxEntiersInfinis(EntierInfini e1,EntierInfini e2);
	// retourne un EntierInfini qui est le rsultat de e1 div e2
	// retourne l'erreur 300 si e2=0,  savoir : "Division entire par un nombre nul"

	EntierInfini calculerLeResteDeLaDivisionDeDeuxEntiersInfinis(EntierInfini e1,EntierInfini e2);
	// retourne un EntierInfini qui est le rsultat de e1 mod e2
	// retourne l'erreur 301 si e2=0,  savoir : "Reste de la division entire par un nombre nul!"

	int sontDeuxEntiersInfinisEgaux(EntierInfini e1,EntierInfini e2);
	// renvoie 1 si e1=e2
	// 0 sinon

	int estUnEntierInfiniSuperieurAUnEntierInfini(EntierInfini e1,EntierInfini e2);
	// renvoie 1 si e1>=e2
	// 0 sinon

	int estUnEntierInfiniStrictementSuperieurAUnEntierInfini(EntierInfini e1,EntierInfini e2);
	// renvoie 1 si e1>e2
	// 0 sinon

	int estUnEntierInfiniInferieurAUnEntierInfini(EntierInfini e1,EntierInfini e2);
	// renvoie 1 si e1<=e2
	// 0 sinon

	int estUnEntierInfiniStrictementInferieurAUnEntierInfini(EntierInfini e1,EntierInfini e2);
	// renvoie 1 si e1<e2
	// 0 sinon

	EntierInfini calculerFactorielleDe(EntierInfini e);
	// retourne un EntierInfini qui est le rsultat de e!
	// retourne l'erreur 302 si e<0,  savoir : "Factorielle d'un entier ngatif!"

	EntierInfini calculerArrangementDe(EntierInfini e1,EntierInfini e2);
	// retourne un EntierInfini qui est le rsultat de A(n,p)=A(e1,e2)
	// retourne l'erreur 303 si e1<0,  savoir : "Arrangement A(n,p) avec n ngatif!"
	// retourne l'erreur 304 si e2<0,  savoir : "Arrangement A(n,p) avec p ngatif!"

	EntierInfini calculerCombinaisonDe(EntierInfini e1,EntierInfini e2);
	// retourne un EntierInfini qui est le rsultat de C(n,p)=C(e1,e2)
	// retourne l'erreur 305 si e1<0,  savoir : "Combinaison C(n,p) avec n ngatif!"
	// retourne l'erreur 306 si e2<0,  savoir : "Combinaison C(n,p) avec p ngatif!"	

	char* afficherUnEntierInfiniAPartirDe(EntierInfini e);
	// retourne une chane de caractres correspondant  l' EntierInfini e
	// si e est ngatif, la chane de caractres rsultat a pour premier caractre '-' 

	void libererEntierInfini(EntierInfini e);
	// permet de librer un EntierInfini

        char* additionnerDeuxPartiesEntieres(char*,char*);
        // Necessaire pour les ReelInfinis

        char* enleverLesZerosEnTete(char*);
        // Necessaire pour les ReelInfinis

        char* soustraireDeuxPartiesEntieres(char*,char*);
        // Necessaire pour les ReelInfinis

        char* obtenirValeurEntierInfini(EntierInfini);
        // Necessaire pour les ReelInfinis

#endif

