/*
 * $Header: /home/etud/asi01/acordier/cvsd/root/repository/Calculette/Error.c,v 1.2 2002/02/25 18:14:13 mchambre Exp $
 *
 *
 *
 * $Log: Error.c,v $
 * Revision 1.2  2002/02/25 18:14:13  mchambre
 *
 * Changements : Grammaire permettant plusieurs calcul et l'affichage du
 *               resultat.
 *               Le point virgule sert de marqueur de fin de saisie.
 *               Appui sur la touche Entree entraine le parcours de l'arbre.
 *
 * Erreurs : On a une erreur de syntaxe pour un calcul succedant a un calcul
 *           sans point-virgule a la fin.
 *
 * Ajout : makefile realisant la compilation bison flex gcc et le lancement
 *         de l'executable.
 *
 * Revision 1.1.1.1  2002/02/20 09:40:29  mchambre
 * Version Initiale
 *
 * Revision 1.3  2001/12/18 23:37:47  seb
 *  - MAJ par rapport au header R1.4
 *  - ajout de fonctions de debug et de macro
 *  - reste un segmentation fault ... TOFIX
 *  - gestion interne a l'aide listes chaines
 *
 * Revision 1.2  2001/12/11 22:16:41  seb
 *  - ajout de log et d'un header
 *  - version non cohrente avec le nouveau error.h r1.4
 *  - a mettre a jour ... [TODO]
 *
 */

#include <stdio.h>
#include "Error.h"

// 3 niveaux de debuggage 0 1 2 (pas de debug -->  bcp de debug)
#define __DEBUG__ 1
#define DEBUG(txt) if (__DEBUG__) printf("%s\n",txt)
#define DEBUG2(txt) if (__DEBUG__ > 1) printf("%s\n",txt)

int	numErreur;
// variable globale contenant le numero de l'erreur

struct 	erreur{

  int	numero;
  char*	detailErreur;
  struct erreur* next;
 
} *tableErreur;


/*****************************************************************************
 * Fonctions
 ****************************************************************************/

/********** Fonctions de Debug **********************************************/

void printStruct(struct erreur* err){
  if (err != NULL){
    printf("erreur numero %d = %s\n",err->numero,err->detailErreur);
  } else {
    printf("structure vide :(");
  };

};

         /*********************/

void printAll(struct erreur* err){
  if ( err != NULL ){
    printStruct(err);
    printAll(err->next);
  };
};

/************ Fonctions internes ********************************************/

void addError(int number, char* txt, struct erreur* err){

  err->next = (struct erreur *) malloc (sizeof(struct erreur));
  err = err->next;
  err->numero = number;
  err->detailErreur = txt;
  err->next = NULL;
};


/************ Fonctions gnrales *******************************************/

struct erreur* findError(struct erreur* err, int elt){
  // renvoie la struture contenant l'erreur,
  // si celle ci est introuvable renvoie NULL

  DEBUG2("-> findError ...");
  
  if (err->numero == elt){
    // on regarde si l'element est deja dans la liste
    DEBUG("--> Trouv !!");
    return(err);
 
  } else if (err->next == NULL) {

    DEBUG("--> Introuvable :(");
    return(err);
    // on doit enregistrer l'erreur sur le suivant que l'on fixe
 
  } else return(findError(err->next,elt));
};

	/*********************/

int enregistrerErreur(int number, char* detailErreur){
	
  struct erreur *Err;

  if (tableErreur == NULL){
    // cas du premier enregistrement d'erreur
    // la table n'est pas initialise, on l'init puis on remplit 
   
    tableErreur = (struct erreur *) malloc (sizeof(struct erreur));
    Err->numero = number;
    Err->detailErreur = detailErreur;
    Err->next = NULL;
    tableErreur = Err;

    DEBUG("-> initialisation de tableErreur\n");
    return(0);
  };

  if ((Err = findError(tableErreur,number)) != NULL){
    
    if( Err->numero == number){
      // il y a deja une entre pour cette erreur
      DEBUG("Erreur deja enregistr\n");
      Err->detailErreur = detailErreur;
    } else {
      DEBUG("Il va falloir remplir le NEXT");
      addError(number,detailErreur,Err);
    };
  };
  
  return (0);
};

	/*********************/

int verifierErreur(void){
	return(numErreur);
};

	/*********************/

int signalerErreur(int numeroErreur){
  if(numeroErreur != 0 ){
    numErreur = numeroErreur;
    return(1);
  } else {
    return(0);
  };
};

	/*********************/

char* expliquerErreur(int numeroErreur){
  struct erreur	*Err;

  if ((Err = findError(tableErreur,numeroErreur)) == NULL)
    return NULL;
  else
    return(Err->detailErreur);
};

	/*********************/

void noErreur(void){
  numErreur = 0;
};









