//--------------------------------------//
//	                           	      // 
//		        Liste.h			// 
//            TT2 - TEAM                // 			 
//--------------------------------------//   

#ifndef LISTE_H 	
#define LISTE_H 	
#define Chaine char* 	
#include "Booleen.h"     
#include "Variable.h"            

typedef struct Liste * Liste;
     
//------------// 
/*Erreurs     */ 
//------------//  

void signalerErreurListe(int); 
void enregistrerErreursListe();   

//------------// 
/*Constructeur*/ 
//------------//  

Liste creerListe ();      

//---------------// 
/*Fonctionnalites*/ 
//---------------//     

/*-----------------------------*/ 
/* Teste si une liste est vide.*/ 
/*-----------------------------*/  

Booleen estVide(Liste);    

/*--------------------------------------------------*/ 
/* Teste si une variable est prsente dans la liste.*/ 
/*--------------------------------------------------*/  

Booleen estPresentDansListe(Liste, Chaine);    

/*---------------------------------------------*/ 
/* Renvoie la variable situe en tte de liste.*/ 
/*---------------------------------------------*/  

Variable obtenirValeur(Liste);    

/*---------------------------------------*/ 
/* Obtenir la liste suivante d'une liste.*/ 
/*---------------------------------------*/  

Liste obtenirListeSuivante(Liste);    
/*---------------------------------------------------------*/ 
/* Renvoie une variable si elle est prsente dans la liste.*/ 
/*---------------------------------------------------------*/  

Variable rechercherDansListe(Liste, Chaine); 	  
/*-------------------------------------*/ 
/* Fixe la liste suivante             .*/ 
/*-------------------------------------*/  

Liste fixerListeSuivante(Liste, Liste);    

/*-------------------------------------*/ 
/* Supprime une variable dans la liste.*/ 
/*-------------------------------------*/  

Liste supprimerElementDansListe(Liste, Chaine);   

/*-------------------------------------*/ 
/* Supprime une liste.                 */ 
/*-------------------------------------*/  

void supprimerListe(Liste);  

/*--------------------------------------*/ 
/* Ajoute une variable en tte de liste.*/ 
/*--------------------------------------*/  

Liste ajouterElementDansListe(Liste, Variable);   

#endif 