#include "Variable.h"
#include "Memoire.h"
#include "Liste.h"
#include "Matrice.h"

struct Memoire{
	Liste l;
};

Memoire memoire(void){
	Memoire m;
 	(m->l)=creerListe();
	return m;
}

Memoire creerVariable(Memoire m,Chaine ch){
	Variable var;
	var=nouvelleVariable(ch);
	(m->l)=ajouterElementDansListe((m->l),var);
	return m;
}

Booleen existe(Memoire m, Chaine ch){
	return(estPresentDansListe((m->l),ch));
}

Booleen estUnEntier(Memoire m,Chaine ch){
	Variable var;
	var=rechercherDansListe((m->l),ch);
	return(estUneVariableEntier(var));
}

Booleen estUnReel(Memoire m, Chaine ch){
	Variable var;
	var=rechercherDansListe((m->l),ch);
	return(estUneVariableReel(var));
}

Booleen estUneMatrice(Memoire m, Chaine ch){
	Variable var;
	var=rechercherDansListe((m->l),ch);
	return(estUneVariableMatrice(var));
}

void fixerValeurEntier(Memoire m, Chaine ch, EntierInfini e){
	Variable var;
	var=rechercherDansListe((m->l),ch);
	fixerVariableEntier(var,e);
}


void fixerValeurReel(Memoire m, Chaine ch, ReelInfini r){
	Variable var;
	var=rechercherDansListe((m->l),ch);
	fixerVariableReel(var,r);
}

void fixerValeurMatrice(Memoire m, Chaine ch, Matrice mat){
	Variable var;
	var=rechercherDansListe((m->l),ch);
	fixerVariableMatrice(var,mat);
}

EntierInfini obtenirValeurEntiere(Memoire m, Chaine ch){
	Variable var;
	var=rechercherDansListe((m->l),ch);
	return(obtenirVariableEntier(var));
}

ReelInfini obtenirValeurReel(Memoire m, Chaine ch){
	Variable var;
	var=rechercherDansListe((m->l),ch);
	return(obtenirVariableReel(var));
}

Matrice obtenirValeurMatrice(Memoire m, Chaine ch){
	Variable var;
	var=rechercherDansListe((m->l),ch);
	return(obtenirVariableMatrice(var));
}

void libererVariable(Memoire m, Chaine ch){
	(m->l)=supprimerElementDansListe((m->l),ch);
}

void libererMemoire(Memoire m){
	supprimerListe(m->l);
}
