 //////////////////////////////////////////////////////////////////
 /*                                                              */
 /*                       Memoire.h                              */
 /*                                                              */
 /*		    Groupe de T.T. numro 2                      */
 ////////////////////////////////////////////////////////////////// 

 //---------------------------
 //Plage d'erreurs : 201  299 
 //--------------------------- 
//typedef enum {Faux=0, Vrai=1} Booleen;

#ifndef MEMOIRE_H 
#define MEMOIRE_H 
#define Chaine char*   

#include "Booleen.h"
#include "EntierInfini.h"		 
#include "ReelInfini.h" 
#include "Matrice.h" 
 
//#include "Error.h"  
//--------------------------------------------------
// Le type mmoire est un pointeur sur une structure
//-------------------------------------------------- 

 typedef struct Memoire * Memoire;    

//------------------------------------------------------------------- 
// Constructeur : permet de crer une mmoire (ensemble de variables)
// ERREUR 266 : s'il n'y a plus de place
//-------------------------------------------------------------------  

Memoire memoire(void);   

//------------------------------------------------------------ 
// Constructeur : permet de crer une variable dans la mmoire 
// ERREUR 266 : s'il n'y a plus de place
//------------------------------------------------------------ 
 
Memoire creerVariable(Memoire, Chaine);  
 
//---------------------------------------------------- 
// Test sur l'existence d'une variable dans la mmoire 
// Paramtres : la mmoire, le nom de la variable 
// ERREUR 244 : si la mmoire n'est pas valide 
//----------------------------------------------------  

Booleen existe(Memoire, Chaine);     

//---------------------------------------------------------- 
// Tests sur le type d'une variable PRESENTE dans la mmoire 
// Paramtres : la mmoire, le nom de la variable 
// ERREUR 222 : si la variable n'existe pas 
// ERREUR 244 : si la mmoire n'est pas valide 
//---------------------------------------------------------- 

 Booleen estUnEntier(Memoire, Chaine);
 Booleen estUnReel(Memoire, Chaine); 
 Booleen estUneMatrice(Memoire, Chaine);   

//---------------------------------------------------------- 
// Fixer la valeur d'une variable PRESENTE selon son type 
// Paramtres : la mmoire, le nom de la variable, la valeur 
// ERREUR 222 : si la variable n'existe pas 
// ERREUR 244 : si la mmoire n'est pas valide 
//----------------------------------------------------------  

void fixerValeurEntier(Memoire, Chaine, EntierInfini);
 void fixerValeurReel(Memoire, Chaine, ReelInfini);
 void fixerValeurMatrice(Memoire, Chaine, Matrice);     

//--------------------------------------------------------- 
// Obtenir la valeur d'une variable PRESENTE selon son type 
// Paramtres : la mmoire, le nom de la variable 
// ERREUR 222 : si la variable n'existe pas 
// ERREUR 244 : si la mmoire n'est pas valide 
//--------------------------------------------------------- 

 EntierInfini obtenirValeurEntiere(Memoire, Chaine);
 ReelInfini obtenirValeurReel(Memoire, Chaine);
 Matrice obtenirValeurMatrice(Memoire, Chaine);    

//------------------------------------------------- 
// Destructeur de variable PRESENTE dans la mmoire 
// Paramtres : la mmoire, le nom de la variable 
// ERREUR 222 : si la variable n'existe pas 
//-------------------------------------------------   

 void libererVariable(Memoire, Chaine);     

//---------------------------------------- 
// Destructeur de memoire 
// Paramtres : la mmoire 
// ERREUR 244 : si la mmoire n'existe pas 
//---------------------------------------- 

 void libererMemoire(Memoire); 

 #endif 
