#include<stdio.h>
#include "OperateursSpeciaux.h"
ReelInfini sommeDesInverses(EntierInfini);

ReelInfini obtenirPI(){
	
	// declaration des variables
	ReelInfini resultat,somme,signe,i,moins_un,zero,un ,deux,quatre;  					   
	
	// initialisation des variables
	moins_un=creerUnReelInfiniAPartirDe("1","0",'-');			 
	zero=creerUnReelInfiniAPartirDe("0","0",'+');
	un=creerUnReelInfiniAPartirDe("1","0",'+');
	deux=creerUnReelInfiniAPartirDe("2","0",'+');
	quatre=creerUnReelInfiniAPartirDe("4","0",'+');	
	resultat=zero;             							  
	somme=un;                
	signe=un;
	i=zero;
	  	  	              							    
	// tant que la somme a rajouter est differente de 0 on rentre ds la boucle car son rajout au resultat  ne sera pas negligeable
	while(sontDeuxReelsInfinisEgaux(somme,zero)!=1){            						            
		// calcul de la somme a rajouter 
		somme=diviserDeuxReelsInfinis(signe,additionnerDeuxReelsInfinis(multiplierDeuxReelsInfinis(deux,i),un));  
		// changement de signe dans le calcul de la somme
		signe=multiplierDeuxReelsInfinis(signe,moins_un); 						        
		// incrementation de i
		i=additionnerDeuxReelsInfinis(i,un);          						
	}	
	
	// on calcule le resultat multilplie par 4 car on a calcule PI/4 avec la boucle
	resultat=multiplierDeuxReelsInfinis(resultat,quatre);
	
	// on libere la memoire
	libererReelInfini(somme);
	libererReelInfini(signe);
	libererReelInfini(i);
	libererReelInfini(moins_un);
	libererReelInfini(zero);
	libererReelInfini(un);
	libererReelInfini(deux);
	libererReelInfini(quatre);
	
	// on renvoie le resultat
	return resultat;				    
}




ReelInfini obtenirLogarithme(ReelInfini nombre,ReelInfini base){
	
	// declaration des variables
	ReelInfini resultat,somme,signe,i,moins_un,zero,un;   
	
	// initialisation des variables
	moins_un=creerUnReelInfiniAPartirDe("1","0",'-');
	zero=creerUnReelInfiniAPartirDe("0","0",'+');								 
	un=creerUnReelInfiniAPartirDe("1","0",'+');
	
	//gestion erreur 502 on a rentre un nombre<=0 en parametre
	enregistrerErreur(502,"impossible il faut rentrer un nombre >0");

 	if (estUnReelInfiniSuperieurAUnReelInfini(zero,nombre)==1){
		libererReelInfini(zero);
		libererReelInfini(un);
		signalerErreur(502);		
		return(moins_un);
   	}
	
	//gestion erreur 503 on a rentre une base<=0 ou une base=1 en parametre
	enregistrerErreur(503,"impossible la base doit etre >0 et different de 1");

 	if (estUnReelInfiniSuperieurAUnReelInfini(zero,base)==1 || sontDeuxReelsInfinisEgaux(base,un)==1){
		libererReelInfini(zero);
		libererReelInfini(un);
		signalerErreur(503);		
		return(moins_un);
   	}
	
	//cas ou on rentre un nombre=0
	if (sontDeuxReelsInfinisEgaux(zero,nombre)==1){
		libererReelInfini(moins_un);
		libererReelInfini(un);		
		return(zero);
   	}
	
	
	// suite de l'initialisation des variables si pas d'erreur	                               	                        
	somme=un;            	                
	signe=un;
	i=un;
	                 	                  	
	if(ReelInfiniEstSuperieurA(nombre,un)==1){
		// tant que la somme a rajouter est differente de 0 on rentre ds la boucle car son rajout au resultat  ne sera pas negligeable
		while(sontDeuxReelsInfinisEgaux(somme,zero)!=1){ 		
		
			somme=diviserDeuxReelsInfinis(multiplierDeuxReelsInfinis(signe,obtenirPuissance(soustraireDeuxReelsInfinis(nombre,un),convertirUnReelInfiniVersUnEntierInfini(i))),i);
			resultat=additionnerDeuxReelsInfinis(resultat,somme);			
		}
	}
	else{
		// tant que la somme a rajouter est differente de 0 on rentre ds la boucle car son rajout au resultat  ne sera pas negligeable
		while(sontDeuxReelsInfinisEgaux(somme,zero)!=1){     		
		
			somme=diviserDeuxReelsInfinis(obtenirPuissance(soustraireDeuxReelsInfinis(un,nombre),convertirUnReelInfiniVersUnEntierInfini(i)),i);
			resultat=additionnerDeuxReelsInfinis(resultat,somme);
		}
	}
	
	if(ReelInfiniEstSuperieurA(nombre,un)!=1)
	resultat=multiplierDeuxReelsInfinis(resultat,moins_un);
	
	// on libere la memoire
	libererReelInfini(somme);
	libererReelInfini(signe);
	libererReelInfini(i);
	libererReelInfini(moins_un);
	libererReelInfini(zero);
	libererReelInfini(un);

	// on renvoie le resultat
	if(sontDeuxReelsInfinisEgaux(base,obtenirE())==1)
		return resultat;	
	else 
		return(diviserDeuxReelsInfinis(resultat,obtenirLogarithme(base,obtenirE())));

}




/*Fonction calculant n^p*/

ReelInfini obtenirPuissance(ReelInfini nb,EntierInfini p)
{

EntierInfini i;
ReelInfini res;
EntierInfini zero;
EntierInfini un;
res=creerUnReelInfiniAPartirDe("1","0",'+');
zero=creerUnEntierInfiniAPartirDe("0",'+');
un=creerUnEntierInfiniAPartirDe("1",'+');

if(sontDeuxEntiersInfinisEgaux(p,zero))
  {
  res=creerUnReelInfiniAPartirDe("1","0",'+');
  }
else
{
  
	for(i=creerUnEntierInfiniAPartirDe("1",'+');estUnEntierInfiniInferieurAUnEntierInfini(i,p);i=additionnerDeuxEntiersInfinis(i,un))
  		{
    		res=multiplierDeuxReelsInfinis(res,nb);
  		}
  
}
libererEntierInfini(i);
libererEntierInfini(p);
libererEntierInfini(zero);
libererEntierInfini(un);

return (res);

}



/*Constante d'Euler_Masheroni*/




/*Fonction calculant la moyenne de Un et Vn, c'est  dire la constante Euler Masheroni*/


ReelInfini eulerMasheroni()
{

ReelInfini Un;
ReelInfini Vn;
EntierInfini n;
EntierInfini i;
EntierInfini un;
ReelInfini deux;

un=creerUnEntierInfiniAPartirDe("1",'+');
deux=creerUnReelInfiniAPartirDe("2","0",'+');

for(i=creerUnEntierInfiniAPartirDe("0",'+');estUnEntierInfiniInferieurAUnEntierInfini(i,n);i=additionnerDeuxEntiersInfinis(i,un))
  {
    Un=soustraireDeuxReelsInfinis(sommeDesInverses(n),(obtenirLogarithme(convertirUnEntierInfiniVersUnReelInfini(n),obtenirE())));
    Vn=soustraireDeuxReelsInfinis(Un,convertirUnEntierInfiniVersUnReelInfini(diviserDeuxEntiersInfinis(un,i)));
  }

libererEntierInfini(i);
libererEntierInfini(un);
libererReelInfini(deux);

return (diviserDeuxReelsInfinis(soustraireDeuxReelsInfinis(Un,Vn),deux));
}


/*Fonction calculant la somme Des Inverses (suite harmonique)*/

ReelInfini sommeDesInverses(EntierInfini nite)
{

EntierInfini i;
ReelInfini somme;
EntierInfini un;

un=creerUnEntierInfiniAPartirDe("1",'+');
somme=creerUnReelInfiniAPartirDe("1","0",'+');

for(i=creerUnEntierInfiniAPartirDe("1",'+');estUnEntierInfiniInferieurAUnEntierInfini(i,nite);i=additionnerDeuxEntiersInfinis(i,un))
  {
    somme=additionnerDeuxReelsInfinis(somme,convertirUnEntierInfiniVersUnReelInfini(diviserDeuxEntiersInfinis(un,i)));
  }

libererEntierInfini(i);
libererEntierInfini(un);
return (somme);
  


}




ReelInfini obtenirExponentielle(ReelInfini nombre)
{
  EntierInfini zero;
  EntierInfini un;
  EntierInfini i;
  ReelInfini resultat;
  ReelInfini temp;
  
  
  zero=creerUnEntierInfiniAPartirDe("0",'+');
  un=creerUnEntierInfiniAPartirDe("1",'+');
  resultat=creerUnReelInfiniAPartirDe("1","0",'+');
  temp=creerUnReelInfiniAPartirDe("0","0",'+');
  i=creerUnEntierInfiniAPartirDe("1",'+');
  
  while(sontDeuxReelsInfinisEgaux(diviserDeuxReelsInfinis(obtenirPuissance(nombre,i),convertirUnEntierInfiniVersUnReelInfini(calculerFactorielleDe(i))),convertirUnEntierInfiniVersUnReelInfini(zero))==1)
    {
      temp=resultat;
      resultat=additionnerDeuxReelsInfinis(resultat,diviserDeuxReelsInfinis(obtenirPuissance(nombre,i),convertirUnEntierInfiniVersUnReelInfini(calculerFactorielleDe(i))));
      i=additionnerDeuxEntiersInfinis(i,un);
    }
  libererReelInfini(temp);
  if(sontDeuxReelsInfinisEgaux(nombre,convertirUnEntierInfiniVersUnReelInfini(zero))==1)
    return(convertirUnEntierInfiniVersUnReelInfini(un));

  
  if(estUnReelInfiniSuperieurAUnReelInfini(nombre,convertirUnEntierInfiniVersUnReelInfini(zero))==1)
    {
    resultat=diviserDeuxReelsInfinis(convertirUnEntierInfiniVersUnReelInfini(un),resultat);
    libererEntierInfini(zero);
    libererEntierInfini(un);
    return(resultat);
    }
  else
    {
    libererEntierInfini(zero);
    libererEntierInfini(un);
    return(resultat);
    }
}


ReelInfini obtenirE()
{
  ReelInfini un;
  un=creerUnReelInfiniAPartirDe("1","0",'+');
  return obtenirExponentielle(un);
}





ReelInfini obtenirRacineCarree(ReelInfini nb)

{

 ReelInfini r1;
 ReelInfini r2;
 ReelInfini e;
 ReelInfini r;
 ReelInfini un;
 ReelInfini zero;
 ReelInfini deux;
 ReelInfini moinsun;

 r1=creerUnReelInfiniAPartirDe("0","0",'+');
 r2=creerUnReelInfiniAPartirDe("0","0",'+');
 e=creerUnReelInfiniAPartirDe("0","0",'+');
 r=creerUnReelInfiniAPartirDe("1","0",'+');
 un=creerUnReelInfiniAPartirDe("1","0",'+');
 zero=creerUnReelInfiniAPartirDe("0","0",'+');
 deux=creerUnReelInfiniAPartirDe("2","0",'+');
 moinsun=creerUnReelInfiniAPartirDe("1","0",'-');

 enregistrerErreur(501,"impossible nbre negatif !!");

 if (estUnReelInfiniStrictementSuperieurAUnReelInfini(zero,nb)==1)
   {
	signalerErreur(501);
	libererReelInfini(r1);
	libererReelInfini(r2);
	libererReelInfini(e);
	libererReelInfini(r);
	libererReelInfini(un);
	libererReelInfini(zero);
	libererReelInfini(deux);
	return(moinsun);
   }

 if (sontDeuxReelsInfinisEgaux(zero,nb)==1)
   {
	libererReelInfini(r1);
	libererReelInfini(r2);
	libererReelInfini(e);
	libererReelInfini(r);
	libererReelInfini(un);
	libererReelInfini(deux);
	libererReelInfini(moinsun);
	return(zero);
   }

 else
   {
	r1=diviserDeuxReelsInfinis((additionnerDeuxReelsInfinis(r,diviserDeuxReelsInfinis(nb,r))),deux);
	libererReelInfini(r);
	while (!sontDeuxReelsInfinisEgaux(e,0))
	{
		r2=diviserDeuxReelsInfinis((additionnerDeuxReelsInfinis(r1,diviserDeuxReelsInfinis(nb,r1))),deux);
		e=soustraireDeuxReelsInfinis(r1,r2);
		r1=r2;
	}
		
	libererReelInfini(r2);
	libererReelInfini(e);
	libererReelInfini(r);
	libererReelInfini(un);
	libererReelInfini(zero);
	libererReelInfini(deux);
	libererReelInfini(moinsun);
	
	return(r1);


   }
}





ReelInfini NombreDOr()

{

 ReelInfini r;
 ReelInfini nombredOr;
 ReelInfini un;
 ReelInfini deux;
 ReelInfini cinq;

 r=creerUnReelInfiniAPartirDe("0","0",'+');
 un=creerUnReelInfiniAPartirDe("1","0",'+');
 deux=creerUnReelInfiniAPartirDe("2","0",'+');
 cinq=creerUnReelInfiniAPartirDe("5","0",'+');

 r=obtenirRacine(cinq);
 nombredOr=diviserDeuxReelsInfinis(additionnerDeuxReelsInfinis(un,r),deux);
 libererReelInfini(r);
 libererReelInfini(un);
 libererReelInfini(deux);
 libererReelInfini(cinq);
 return (nombredOr);
 
 



}
