#include"ReelInfini.h"

static int  nombreDeChiffresSignificatifs;

struct ReelInfini{
	char* partieEntiere;
        char* partieDecimale;
	char signe;
};


void fixerPrecision(int argc){
 nombreDeChiffresSignificatifs = argc;
}   

int obtenirPrecision(){
  return nombreDeChiffresSignificatifs;
}


int max(int a,int b){
  if (a>b)
    return a;
  else
    return b;
}

char multiplierLesSignesDeDeuxReelsInfinis(ReelInfini r1,ReelInfini r2){
	if(r1->signe==r2->signe)
		return '+';
	else
		return '-';
}


void verifierSigneReelInfini(ReelInfini r){
  if ((strcmp(r->partieEntiere,"0")==0)&&(strcmp(r->partieDecimale,"0")))
    r->signe='+';
}

/* fonction qui retire les 0 en queue de la chaine */
char * enleverLesZerosEnQueue(char * chaine){
  int indice,i,nombre,longueur;
  char * resultat;

  indice = strlen(chaine)-1;
  nombre = 0;

  /* parcours de la chaine pour les zros */
  while ((chaine[indice] =='0')&&(indice>=0)){
    indice--;
    nombre++;
  }

  /* reglage pour recopie */

  if (nombre==strlen(chaine)){
    resultat=(char *) calloc(2,sizeof(char));
    resultat[1]='\0';
    resultat[0]='0';
    return resultat;
  }
  else{
    longueur = strlen(chaine)-nombre;
    resultat = (char *) calloc(longueur+1,sizeof(char));
    resultat[longueur] = '\0';

  /* recopie de la chaine sans les 0 */
    for(i=0;i<longueur;i++){
      resultat[i] = chaine[i];
    }

    return resultat;
  }
}


/* fonction d'allocation d'espace pour un entier Infini */
ReelInfini reserverEspacePourReelInfini(){
  return ((ReelInfini) malloc(sizeof(struct ReelInfini)));
}



/* fonction de cration d'un entier Infini */
ReelInfini creerUnReelInfiniAPartirDe(char* partieEntiere,char* partieDecimale,char signe){
  ReelInfini r = reserverEspacePourReelInfini();
  r->partieEntiere=(char *) calloc(strlen(partieEntiere),sizeof(char));
  strcpy(r->partieEntiere,partieEntiere);
  r->partieDecimale=(char *) calloc(strlen(partieDecimale),sizeof(char));
  strcpy(r->partieDecimale,partieDecimale);
  r->signe=signe;
  return r;
}

////////////////////////////////////////////////////////////////////////////////////
//
//                      Fonctions de conversion
//
////////////////////////////////////////////////////////////////////////////////////


//Conversion d'un ReelInfini vers un EntierInfini
EntierInfini convertirUnReelInfiniVersUnEntierInfini(ReelInfini r){
  return creerUnEntierInfiniAPartirDe(r->partieEntiere,r->signe);
  libererReelInfini(r);
}

/* destructeur d'un Entier Infini */
void libererReelInfini(ReelInfini pr){
        printf("ReelInfini.c : Liberation d'un ReelInfini\n");
        free(pr->partieEntiere);
	free(pr->partieDecimale);
	free(pr);
        printf("ReelInfini.c : On sort de libererReelInfini\n");
}



/* affichage d'un entier Infini */
char* afficherUnReelInfiniAPartirDe(ReelInfini r){
	char * temp;
	int longueur,i,indice;
        printf ("ReelInfini.c : afficherUnReelInfiniAParitrDe\n");
	 
	if(r->signe=='+'){
	  longueur = strlen(r->partieEntiere)+strlen(r->partieDecimale)+1;
	  temp = (char *) calloc(longueur+1,sizeof(char));
	  temp[longueur]='\0';
	  i=0;
	  while(i<strlen(r->partieEntiere)){
	    temp[i]=r->partieEntiere[i];
	    i++;
	  }
	  indice=i+1;
	  temp[indice-1]=',';
	  i=0;
	  while(i<strlen(r->partieDecimale)){
	    temp[i+indice]=r->partieDecimale[i];
	    i++;
	  }
	}

	else{
	  longueur = strlen(r->partieEntiere)+strlen(r->partieDecimale)+2;
	  temp = (char *) calloc(longueur+1,sizeof(char));
	  temp[longueur]='\0';
	  i=0;
	  temp[0]='-';
	  while(i<strlen(r->partieEntiere)){
	    temp[i+1]=r->partieEntiere[i];
	    i++;
	  }
	  indice=i+2;
	  temp[indice-1]=',';
	  i=0;
	  while(i<strlen(r->partieDecimale)){
	    temp[i+indice]=r->partieDecimale[i];
	    i++;
	  }
	}
	return temp;
}



/* fonction de somme de deux chaine de caractres */
/* on suppose ke chaine1 > chaine2 */
char * additionnerDeuxPartiesReelles(char * chaine1, char * chaine2){
  char * resultat, * temp;
  int longueur,nb1,nb2,nbresult,reste,deb1,deb2,indice;
  longueur = max(strlen(chaine1),strlen(chaine2));
  resultat = (char *) calloc(longueur+1,sizeof(char));
  resultat[longueur] = '\0';

  /* initialisation des indices de parcours de boucle */
  deb1 = strlen(chaine1) - 1;
  deb2 = strlen(chaine2) - 1;
  reste = 0;

  /* dbut boucle de calcul de l'addition */
  for(indice=longueur-1;indice>=0;indice--){
    if (deb1 < indice)
      nb1 = 0;
    else{
      if (chaine1[deb1]<0x30)
	deb1--;
      nb1 = (int) (chaine1[deb1]-0x30);
      deb1--;
    }

    if (deb2 < indice)
      nb2 = 0;
    else{
      if (chaine2[deb2]<0x30)
	deb2--;
      nb2 = (int) (chaine2[deb2]-0x30);
      deb2--;
    }

    nbresult = nb1 + nb2 + reste;
    reste = nbresult / 10;
    resultat[indice] =(char) ((nbresult % 10)+0x30);

  }
  temp = resultat;
  resultat = enleverLesZerosEnQueue(temp);
  free(temp);
  return resultat;
}


/* soustraction des parties Entieres */
char * soustraireDeuxPartiesReelles(char * chaine1,char * chaine2){
  char * resultat, * temp;
  int longueur,nb1,nb2,nbresult,reste,deb1,deb2,indice;
  longueur = max(strlen(chaine1),strlen(chaine2));
  resultat = (char *) calloc(longueur+1,sizeof(char));
  resultat[longueur] = '\0';

  /* initialisation des indices de parcours de boucle */
  deb1 = strlen(chaine1) - 1;
  deb2 = strlen(chaine2) - 1;
  reste = 0;

  /* dbut boucle de calcul de l'addition */
  for(indice=longueur-1;indice>=0;indice--){
    if (deb1 < indice)
      nb1 = 0;
    else{
      if (chaine1[deb1]<0x30)
	deb1--;
      nb1 = (int) (chaine1[deb1]-0x30);
      deb1--;
    }

    if (deb2 < indice)
      nb2 = 0;
    else{
      if (chaine2[deb2]<0x30)
	deb2--;
      nb2 = (int) (chaine2[deb2]-0x30);
      deb2--;
    }

    nbresult = nb1 - nb2 - reste;
    if (nbresult < 0){
      nbresult = nbresult + 10;
      reste = 1;
    }
    else
      reste = 0;
    resultat[indice] =(char) ((nbresult % 10)+0x30);

  }
  temp = resultat;
  resultat = enleverLesZerosEnQueue(temp);
  free(temp);
  return resultat;
}


void enlever1AUnReelInfini(ReelInfini r){
  char * temp;
  if (strcmp(r->partieDecimale,"0")==0){
    if (r->signe=='+') r->signe='-';
    else r->signe='+';
  }
  if (r->signe =='+'){
    temp = soustraireDeuxPartiesEntieres(r->partieEntiere,"1");
    free(r->partieEntiere);
    r->partieEntiere = enleverLesZerosEnTete(temp);
    free(temp);
  }
  else{
    temp = additionnerDeuxPartiesEntieres(r->partieEntiere,"1");
    free(r->partieEntiere);
    r->partieEntiere = enleverLesZerosEnTete(temp);
    free(temp);
  }
}

/* fonction qui ajoute 1  un entier Infini */


void ajouter1AUnReelInfini(ReelInfini r){
  char * temp;
  if (strcmp(r->partieDecimale,"0")==0){
    if (r->signe=='+')
      r->signe='-';
    else
      r->signe='+';
  }
  if (r->signe=='+'){
    temp = additionnerDeuxPartiesEntieres(r->partieEntiere,"1");
    free(r->partieEntiere);
    r->partieEntiere = enleverLesZerosEnTete(temp);
    free(temp);
  }
  else{
    temp = soustraireDeuxPartiesEntieres(r->partieEntiere,"1");
    free(r->partieEntiere);
    r->partieEntiere = enleverLesZerosEnTete(temp);
    free(temp);
  }
}


ReelInfini additionnerDeuxReelsInfinis(ReelInfini r1,ReelInfini r2){
  ReelInfini resultat,r1prime,r2prime,maximum;
  char * temp;
  int reste;
  resultat = reserverEspacePourReelInfini();

  if (multiplierLesSignesDeDeuxReelsInfinis(r1,r2)=='+'){
    resultat->partieEntiere = additionnerDeuxPartiesEntieres(r1->partieEntiere,r2->partieEntiere);
    resultat->signe=r1->signe;
    resultat->partieDecimale = additionnerDeuxPartiesReelles(r1->partieDecimale,r2->partieDecimale);
    if (strcmp(r1->partieDecimale,r2->partieDecimale)>=0)
      maximum = r1;
    else
      maximum = r2;
    if (strcmp(maximum->partieDecimale,resultat->partieDecimale)>0)
      ajouter1AUnReelInfini(resultat);
  }

  else{

  /* dtermination du signe */
  /* on cre alors 2 entier Infini qui seront les valeurs absolue des deux
     autrs et on les compare */

    r1prime = creerUnReelInfiniAPartirDe(r1->partieEntiere,r1->partieDecimale,'+');
    r2prime = creerUnReelInfiniAPartirDe(r2->partieEntiere,r2->partieDecimale,'+');

    if (!estUnReelInfiniSuperieurAUnReelInfini(r1prime,r2prime)){
      resultat->signe = r1->signe;
      resultat->partieEntiere = soustraireDeuxPartiesEntieres(r1->partieEntiere,r2->partieEntiere);
      if (strcmp(r1prime->partieDecimale,r2prime->partieDecimale)>0){
	resultat->partieDecimale = soustraireDeuxPartiesReelles(r2->partieDecimale,r1->partieDecimale);
	enlever1AUnReelInfini(resultat);
      }
      else
	resultat->partieDecimale = soustraireDeuxPartiesReelles(r1->partieDecimale,r2->partieDecimale);
    }
    else{
      resultat->signe = r2->signe;
      resultat->partieEntiere = soustraireDeuxPartiesEntieres(r2->partieEntiere,r1->partieEntiere);
      if (strcmp(r2prime->partieDecimale,r1prime->partieDecimale)>0){
	resultat->partieDecimale = soustraireDeuxPartiesReelles(r1->partieDecimale,r2->partieDecimale);
	enlever1AUnReelInfini(resultat);
      }
      resultat->partieDecimale = soustraireDeuxPartiesReelles(r2->partieDecimale,r1->partieDecimale);
    }
    libererReelInfini(r1prime);
    libererReelInfini(r2prime);
  }

  temp = resultat->partieEntiere;

  resultat->partieEntiere = enleverLesZerosEnTete(temp);

  free(temp);

  verifierSigneReelInfini(resultat);
  return resultat;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//                                       La soustraction de 2 ReelInfinis
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////


// soustraction de 2 ReelInfinis
ReelInfini soustraireDeuxReelsInfinis(ReelInfini r1,ReelInfini r2){
  ReelInfini resultat,valeurAbsolu1,valeurAbsolu2;
  EntierInfini r1prime,r2prime;
  resultat = reserverEspacePourReelInfini();

  if (multiplierLesSignesDeDeuxReelsInfinis(r1,r2)=='-'){ // Ils sont de signe differents, on fait donc une addition
    printf ("ReelInfini.c : Soustraction de 2 ReelInfinis de signes differents\n");
    valeurAbsolu1 = creerUnReelInfiniAPartirDe ( r1->partieEntiere , r1->partieDecimale ,'+');
    valeurAbsolu2 = creerUnReelInfiniAPartirDe ( r2->partieEntiere , r2->partieDecimale ,'+');
    resultat = additionnerDeuxReelsInfinis ( valeurAbsolu1 , valeurAbsolu2 );
    if (r1->signe == '+') {resultat->signe = '+';} // (+) - (-) = +
    else {resultat->signe = '-';}                  // (-) - (+) = -
    
  }

  else{                                                                             //Ils sont de meme signe 

    r1prime = creerUnEntierInfiniAPartirDe ( r1->partieEntiere, '+');
    r2prime = creerUnEntierInfiniAPartirDe ( r2->partieEntiere, '+');

    if ( r1->signe == '+') { // Les 2 nombres sont positifs 
      
      if ( estUnEntierInfiniSuperieurAUnEntierInfini ( r1prime, r2prime )) { // La partie entiere du 1er est superieur a celle du 2eme
	resultat->partieEntiere = soustraireDeuxPartiesEntieres ( r1->partieEntiere , r2->partieEntiere);
	resultat->partieEntiere = enleverLesZerosEnTete (resultat->partieEntiere);
	resultat->signe ='+';

	if (strcmp(r1->partieDecimale,r2->partieDecimale)>0 ) { // La partie decimale du 1er est superieur a celle du 2eme (r1 > r2)
	  resultat->partieDecimale = soustraireDeuxPartiesReelles ( r1->partieDecimale,r2->partieDecimale);// (r1 - r2)
	}
      
	else {       // La partie decimale du 1er est inferieur a celle du 2eme (r1 < r2)
	  resultat->partieDecimale = soustraireDeuxPartiesReelles ( r2->partieDecimale,r1->partieDecimale); // On inverse:(r2 - r1)
	  resultat->partieDecimale = soustraireDeuxPartiesReelles ( "0",resultat->partieDecimale);
	  enlever1AUnReelInfini (resultat);
	}
      }

  else { // La partie entiere du 2eme est superieur a celle du 2eme, on fait la soustraction en inversant pour avoir le plus grand en haut
    resultat->partieEntiere = soustraireDeuxPartiesEntieres(r2->partieEntiere,r1->partieEntiere);
    resultat->partieEntiere = enleverLesZerosEnTete (resultat->partieEntiere);
    resultat->signe ='-';

    if (strcmp(r1->partieDecimale,r2->partieDecimale)>0 ) { // La partie decimale du 1er est superieur a celle du 2eme (r1 > r2)
      resultat->partieDecimale = soustraireDeuxPartiesReelles ( r1->partieDecimale,r2->partieDecimale);// (r1 - r2)
      resultat->partieDecimale = soustraireDeuxPartiesReelles ( "0",resultat->partieDecimale);
      ajouter1AUnReelInfini (resultat);
    }

    else {       // La partie decimale du 1er est inferieur a celle du 2eme (r1 < r2)
      resultat->partieDecimale = soustraireDeuxPartiesReelles ( r2->partieDecimale,r1->partieDecimale); // On inverse:(r2 - r1)
    }
  }
}

    else { // Les 2 nombres sont negatifs

      if  ( estUnEntierInfiniSuperieurAUnEntierInfini ( r1prime, r2prime )) { // La partie entiere du 1er est superieur a celle du 2eme, on va donc inverser
	resultat->partieEntiere = soustraireDeuxPartiesEntieres(r1->partieEntiere,r2->partieEntiere);
	resultat->partieEntiere = enleverLesZerosEnTete (resultat->partieEntiere);
	resultat->signe = '-';

	if ( strcmp(r1->partieDecimale,r2->partieDecimale)>0 ) { // La partie decimale du 1er est superieur a celle du 2eme
	  resultat->partieDecimale = soustraireDeuxPartiesReelles ( r1->partieDecimale,r2->partieDecimale);
	}

	else {  // La partie decimale du 1er est inferieur a celle du 2eme
	  resultat->partieDecimale = soustraireDeuxPartiesReelles ( r2->partieDecimale,r1->partieDecimale); // On inverse
	  resultat->partieDecimale = soustraireDeuxPartiesReelles ( "0",resultat->partieDecimale);
	  ajouter1AUnReelInfini (resultat);
	}
      }

      else {
	resultat->partieEntiere = soustraireDeuxPartiesEntieres(r2->partieEntiere,r1->partieEntiere);
	resultat->partieEntiere = enleverLesZerosEnTete (resultat->partieEntiere);
	resultat->signe = '+';
	
	if ( strcmp(r1->partieDecimale,r2->partieDecimale)>0 ) { // La partie decimale du 1er est superieur a celle du 2eme
	  resultat->partieDecimale = soustraireDeuxPartiesReelles ( r2->partieDecimale,r1->partieDecimale);
	  enlever1AUnReelInfini (resultat);
	}
	
	else {  // La partie decimale du 1er est inferieur a celle du 2eme
	  resultat->partieDecimale = soustraireDeuxPartiesReelles ( r1->partieDecimale,r2->partieDecimale); // On inverse
	  resultat->partieDecimale = soustraireDeuxPartiesReelles ("0", resultat->partieDecimale);
	}
      }

    }
    printf ("ReelInfini.c : on va liberer les primes\n");
    libererEntierInfini (r1prime);
    libererEntierInfini (r2prime);
  }
  printf ("ReelInfini.c : on va sortir de ReelInfini.c\n");
  return (resultat);
  printf ("ReelInfini.c : on sort de ReelInfini.c\n");
}




// fonction de multiplication des rels Infini

ReelInfini multiplierDeuxReelsInfinis(ReelInfini r1,ReelInfini r2){

  char * partieEntiere,* partieDecimale, *temp , * temp1, * temp2;
  EntierInfini entierTemp1,entierTemp2,entierResultat;
  int longueurDesReels, longueurTemp1, longueurTemp2;
  ReelInfini resultat;


  resultat = reserverEspacePourReelInfini();
  resultat->signe = multiplierLesSignesDeDeuxReelsInfinis(r1,r2);

  longueurDesReels = strlen(r1->partieDecimale)+strlen(r2->partieDecimale);
  longueurTemp1 = strlen(r1->partieEntiere)+strlen(r1->partieDecimale);
  longueurTemp2 = strlen(r2->partieEntiere)+strlen(r2->partieDecimale);


  temp1 = (char *) calloc(longueurTemp1,sizeof(char));
  strcpy(temp1,r1->partieEntiere);
  strcpy(temp1+strlen(r1->partieEntiere),r1->partieDecimale);



  temp2 = (char *) calloc(longueurTemp2,sizeof(char));
  strcpy(temp2,r2->partieEntiere);
  strcpy(temp2+strlen(r2->partieEntiere),r2->partieDecimale);


  entierTemp1 = creerUnEntierInfiniAPartirDe(temp1,'+');
  entierTemp2 = creerUnEntierInfiniAPartirDe(temp2,'+');

  free(temp1);
  free(temp2);

  entierResultat = multiplierDeuxEntiersInfinis(entierTemp1,entierTemp2);

  libererEntierInfini(entierTemp1);
  libererEntierInfini(entierTemp2);

  temp = obtenirValeurEntierInfini(entierResultat);

  libererEntierInfini(entierResultat);


  if (longueurDesReels>nombreDeChiffresSignificatifs){
    temp1 = (char *) calloc(nombreDeChiffresSignificatifs+1,sizeof(char));
    temp1[nombreDeChiffresSignificatifs] = '\0';
    strncpy(temp1,temp+(strlen(temp)-longueurDesReels),nombreDeChiffresSignificatifs);
    resultat->partieDecimale = enleverLesZerosEnTete(temp1);
  }
  else{
    temp1 = (char *) calloc(longueurDesReels+1,sizeof(char));
    temp1[longueurDesReels]='\0';
    strcpy(temp1,temp+(strlen(temp)-longueurDesReels));
    resultat->partieDecimale = enleverLesZerosEnQueue(temp1);
  }

  temp2 = (char *) calloc(strlen(temp)-longueurDesReels+1,sizeof(char));
  temp2[strlen(temp)-longueurDesReels]='\0';
  strncpy(temp2,temp,strlen(temp)-longueurDesReels);
  resultat->partieEntiere = enleverLesZerosEnTete(temp2);

  free(temp1);
  free(temp2);

  return resultat;
}

void obtenirPartieEntiereEtPartieDecimale(ReelInfini r, EntierInfini partieEntiere, EntierInfini partieDecimale){
	partieEntiere=creerUnEntierInfiniAPartirDe(r->partieEntiere,'+') ;
	partieDecimale=creerUnEntierInfiniAPartirDe(r->partieDecimale,'+') ;
}

/*
void obtenirLeResteEtLeDividendeDeLaDivisionEntiereDe(EntierInfini partieEntiereR1, EntierInfini partieEntiereR2, ReelInfini reste, char* dividende){
	char * temp, chaine ;
	EntierInfini entierInfini ;

	if(estUnEntierInfiniStrictementInferieurAUnEntierInfini(partieEntiereR1, partieEntiereR2)==1){
		temp=(char*) calloc(strlen(dividende)+2, sizeof(char));
		temp=strcat(dividende, "0") ;
	dividende=temp ;
}

else{
	entierInfini=diviserDeuxEntiersInfinis(partieEntiereR1, partieEntiereR2) ;
	chaine=afficherUnEntierInfiniAPartirDe(entierInfini) ;
	libererEntierInfini(entierInfini);
	temp=(char*) calloc(strlen(dividende)+strlen(chaine)+1, sizeof(char)) ;
	temp=strcat(dividende, chaine) ;
	dividende=temp ;

	entierInfini=calculerLeResteDeLaDivisionDeDeuxEntiersInfinis(partieEntiereR1, partieEntiereR2) ;
	chaine=afficherUnEntierInfiniAPartirDe(entierInfini) ;
	libererEntierInfini(entierInfini) ;
	temp=(char*) calloc(strlen(dividende)+strlen(chaine)+1, sizeof(char)) ;
	reste->partieEntiere=temp ;
	}
}

ReelInfini diviserDeuxReelsInfinis(ReelInfini r1, ReelInfini r2){
EntierInfini partieEntiereR1, partieDecimaleR1, partieEntiereR2, partieDecimaleR2, zero ;
	ReelInfini dix, resultat ;
	int longueur ;

	dix=creerUnReelInfiniAPartirDe("10","0",'+') ;
	zero=creerUnEntierInfiniAPartirDe("0", '+') ;

	resultat->signe=multiplierLesSignesDeDeuxReelsInfinis(r1, r2) ;

	partieEntiereR1=creerUnEntierInfiniAPartirDe(r1->partieEntiere, '+') ;
	partieDecimaleR1=creerUnEntierInfiniAPartirDe(r1->partieDecimale, '+') ;
	partieEntiereR2=creerUnEntierInfiniAPartirDe(r2->partieEntiere, '+') ;
	partieDecimaleR2=creerUnEntierInfiniAPartirDe(r2->partieDecimale, '+') ;

	while((sontDeuxEntiersInfinisEgaux(partieEntiereR2, zero)==1)||(sontDeuxEntiersInfinisEgaux(partieDecimaleR2, zero)==0)){
		r2=multiplierDeuxReelsInfinis(r2, dix) ;
		r1=multiplierDeuxReelsInfinis(r1, dix) ;
		obtenirPartieEntiereEtPartieDecimale(r2, partieEntiereR2, partieDecimaleR2) ;
	}
	obtenirPartieEntiereEtPartieDecimale(r1, partieEntiereR1, partieDecimaleR1) ;

	longueur=0 ;

	do{
		r1=multiplierDeuxReelsInfinis(r1, dix) ;
		obtenirPartieEntiereEtPartieDecimale(r1, partieEntiereR1, partieDecimaleR1) ;
		obtenirLeResteEtLeDividendeDeLaDivisionEntiereDe(partieEntiereR1, partieEntiereR2, r1, resultat->partieEntiere) ;
		longueur=longueur+1 ;
	}
	while((strlen(r1->partieDecimale)!=0)) ;

//arrondir(resultat, longueur) ;

return resultat ;
}




void arrondir(ReelInfini resultat, int nombredeChiffresSignificatifsPlusUn){
	ReelInfini temp ;
	char DernierChiffreSignificatifPlusUn ;

	temp=reserverEspacePourReelInfini() ;
DernierChiffreSignificatifPlusUn=resultat->partieDecimale[nombredeChiffresSignificatifs-1] ;

if((DernierChiffreSignificatifPlusUn=='0')||(DernierChiffreSignificatifPlusUn=='1')||(DernierChiffreSignificatifPlusUn=='2')||(DernierChiffreSignificatifPlusUn=='3')||(DernierChiffreSignificatifPlusUn=='4')){
temp=strncp(resultat->partieDecimale, nombreDeChiffreSignificatifsPlusUn-1) ;
resultat->partieDecimale=temp ;
libererReelInfini(temp) ;
	}

	else{
		resultat->partieDecimale[nombredeChiffresSignificatifs-1]='0' ;
		arrondir(resultat, nombreDeChiffresSignificatifs-1) ;
	}
}
*/

int estUnePartieReelleSuperieureAUnePartieReelle(char * ch1,char * ch2){
  if (strcmp(ch1,ch2)>0)
    return 1;
  else
    return 0;
}

int estUnePartieReelleInferieureAUnePartieReelle(char * ch1,char * ch2){
  if (strcmp(ch1,ch2)<0)
    return 1;
  else
    return 0;
}

int estUnePartieReelleEgaleAUnePartieReelle(char * ch1, char * ch2){
  if (strcmp(ch1,ch2)==0)
    return 1;
  else
    return 0;
}



int estUnReelInfiniSuperieurAUnReelInfini(ReelInfini r1 , ReelInfini r2){
  EntierInfini e1,e2;
  e1 = creerUnEntierInfiniAPartirDe(r1->partieEntiere,r1->signe);
  e2 = creerUnEntierInfiniAPartirDe(r2->partieEntiere,r2->signe);
  if (estUnEntierInfiniStrictementSuperieurAUnEntierInfini(e1,e2))
    return 1;
  if (estUnEntierInfiniStrictementInferieurAUnEntierInfini(e1,e2))
    return 0;
  if (sontDeuxEntiersInfinisEgaux(e1,e2)){
    if (r1->signe=='+'){
      if ((strcmp(r1->partieDecimale,r2->partieDecimale)>0)||(strcmp(r1->partieDecimale,r2->partieDecimale)==0))
	return 1;
      else
	return 0;
    }
    else{
      if ((strcmp(r1->partieDecimale,r2->partieDecimale)>0)||(strcmp(r1->partieDecimale,r2->partieDecimale)==0))
	return 0;
      else
	return 1;
    }
  }
  libererEntierInfini(e1);
  libererEntierInfini(e2);
}



int estUnReelInfiniStrictementSuperieurAUnReelInfini(ReelInfini r1 , ReelInfini r2){
  EntierInfini e1,e2;
  e1 = creerUnEntierInfiniAPartirDe(r1->partieEntiere,r1->signe);
  e2 = creerUnEntierInfiniAPartirDe(r2->partieEntiere,r2->signe);
  if (estUnEntierInfiniStrictementSuperieurAUnEntierInfini(e1,e2))
    return 1;
  if (estUnEntierInfiniStrictementInferieurAUnEntierInfini(e1,e2))
    return 0;
  if (sontDeuxEntiersInfinisEgaux(e1,e2)){
    if (r1->signe=='+'){
      if (strcmp(r1->partieDecimale,r2->partieDecimale)>0)
	return 1;
      else
	return 0;
    }
    else{
      if ((strcmp(r1->partieDecimale,r2->partieDecimale)>0))
	return 0;
      else
	return 1;
    }
  }
  libererEntierInfini(e1);
  libererEntierInfini(e2);
}



int estUnReelInfiniInferieurAUnReelInfini(ReelInfini r1 , ReelInfini r2){
  EntierInfini e1,e2;
  e1 = creerUnEntierInfiniAPartirDe(r1->partieEntiere,r1->signe);
  e2 = creerUnEntierInfiniAPartirDe(r2->partieEntiere,r2->signe);
  if (estUnEntierInfiniStrictementSuperieurAUnEntierInfini(e1,e2))
    return 0;
  if (estUnEntierInfiniStrictementInferieurAUnEntierInfini(e1,e2))
    return 1;
  if (sontDeuxEntiersInfinisEgaux(e1,e2)){
    if (r1->signe=='+'){
      if ((strcmp(r1->partieDecimale,r2->partieDecimale)<0)||(strcmp(r1->partieDecimale,r2->partieDecimale)==0))
	return 1;
      else
	return 0;
    }
    else{
      if ((strcmp(r1->partieDecimale,r2->partieDecimale)<0)||(strcmp(r1->partieDecimale,r2->partieDecimale)==0))
	return 0;
      else
	return 1;
    }
  }
  libererEntierInfini(e1);
  libererEntierInfini(e2);
}



int estUnReelInfiniStrictementInferieurAUnReelInfini(ReelInfini r1 , ReelInfini r2){
  EntierInfini e1,e2;
  e1 = creerUnEntierInfiniAPartirDe(r1->partieEntiere,r1->signe);
  e2 = creerUnEntierInfiniAPartirDe(r2->partieEntiere,r2->signe);
  if (estUnEntierInfiniStrictementSuperieurAUnEntierInfini(e1,e2))
    return 0;
  if (estUnEntierInfiniStrictementInferieurAUnEntierInfini(e1,e2))
    return 1;
  if (sontDeuxEntiersInfinisEgaux(e1,e2)){
    if (r1->signe=='+'){
      if (strcmp(r1->partieDecimale,r2->partieDecimale)<0)
	return 1;
      else
	return 0;
    }
    else{
     if (strcmp(r1->partieDecimale,r2->partieDecimale)<0)
	return 0;
      else
	return 1;
    }
  }
  libererEntierInfini(e1);
  libererEntierInfini(e2);
}


int sontDeuxReelsInfinisEgaux(ReelInfini r1 , ReelInfini r2){
  EntierInfini e1,e2;
  e1 = creerUnEntierInfiniAPartirDe(r1->partieEntiere,r1->signe);
  e2 = creerUnEntierInfiniAPartirDe(r2->partieEntiere,r2->signe);
  if (estUnEntierInfiniStrictementSuperieurAUnEntierInfini(e1,e2))
    return 0;
  if (estUnEntierInfiniStrictementInferieurAUnEntierInfini(e1,e2))
    return 0;
  if (sontDeuxEntiersInfinisEgaux(e1,e2)){
      if (strcmp(r1->partieDecimale,r2->partieDecimale)==0)
	return 1;
      else
	return 0;
  }
  else
    return 0;
  libererEntierInfini(e1);
  libererEntierInfini(e2);
}



// retourne un ReelInfini qui est l'oppose de r
ReelInfini prendreOpposeDUnReelInfini(ReelInfini r) {
  if ( r->signe == '+' ) r->signe = '-';
  else r->signe = '+';
  return r;
}

