#include<stdio.h>
#include<stdlib.h>
#include"Matrice.h"
#include"Error.h"
#include"OperateursSpeciaux.h"
#include"OperateursTrigonometriques.h"
#include"EntierInfini.h"
#include"ReelInfini.h"
#include"Memoire.h"
#include"Booleen.h"
#include"max.h"


// Les fonctions trigonomtriques de base

// La fonction sinus

typeRetourneParDollar calculerSinus(typeRetourneParDollar terme1)
{
	if (terme1.type==2)		/* terme1 est une Matrice*/  
		{exit(1);}
	else
		typeRetourneParDollar resultat;
		resultat.type=0;
		
		if (terme1.type==1) 	/* terme1 est un Rel*/
			{
			 resultat.notreReel=obtenirSinus(terme1.notreReel);
			}
		
		else			/* terme1 est un Entier*/	
			{
			 resultat.notreReel=obtenirSinus(convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier));
			}
	
	libererStruct(terme1);	
	resultat.aDetruire=0;
	return resultat;
}	

// La fonction cosinus

typeRetourneParDollar calculerCosinus(typeRetourneParDollar terme1)
{
	if (terme1.type==2)		/* terme1 est une Matrice*/  
		{exit(1);}
	else
		typeRetourneParDollar resultat;
		resultat.type=0;
		
		if (terme1.type==1) 	/* terme1 est un Rel*/
			{
			 resultat.notreReel=obtenirCosinus(terme1.notreReel);
			}
		
		else			/* terme1 est un Entier*/	
			{
			 resultat.notreReel=obtenirCosinus(convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier));
			}
	
	libererStruct(terme1);	
	resultat.aDetruire=0;
	return resultat;
}

// La fonction tangente

typeRetourneParDollar calculerTangente(typeRetourneParDollar terme1)
{
	if (terme1.type==2)		/* terme1 est une Matrice*/  
		{exit(1);}
	else
		typeRetourneParDollar resultat;
		resultat.type=0;
		
		if (terme1.type==1) 	/* terme1 est un Rel*/
			{
			 resultat.notreReel=obtenirTangente(terme1.notreReel);
			}
		
		else			/* terme1 est un Entier*/	
			{
			 resultat.notreReel=obtenirTangente(convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier));
			}
	
	libererStruct(terme1);	
	resultat.aDetruire=0;
	
	if (verifierErreur()==401)
		{
		printf("Erreur : %s\n",expliquerErreur(401));
		libererStruct(resultat);
		exit(1);
		}
	
	return resultat;
}

// La fonction cotangente

typeRetourneParDollar calculerCoTangente(typeRetourneParDollar terme1)
{
	if (terme1.type==2)		/* terme1 est une Matrice*/  
		{exit(1);}
	else
		typeRetourneParDollar resultat;
		resultat.type=0;
		
		if (terme1.type==1) 	/* terme1 est un Rel*/
			{
			 resultat.notreReel=obtenirCoTangente(terme1.notreReel);
			}
		
		else			/* terme1 est un Entier*/	
			{
			 resultat.notreReel=obtenirCoTangente(convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier));
			}
	
	libererStruct(terme1);	
	resultat.aDetruire=0;
	
	if (verifierErreur()==402)
		{
		printf("Erreur : %s\n",expliquerErreur(402));
		libererStruct(resultat);
		exit(1);
		}
	
	return resultat;
}

// Les fonctions hyperboliques

// La fonction cosinus hyperbolique

typeRetourneParDollar calculerArcCosinus(typeRetourneParDollar terme1)
{
	if (terme1.type==2)		/* terme1 est une Matrice*/  
		{exit(1);}
	else
		typeRetourneParDollar resultat;
		resultat.type=0;
		
		if (terme1.type==1) 	/* terme1 est un Rel*/
			{
			 resultat.notreReel=obtenirArcCosinus(terme1.notreReel);
			}
		
		else			/* terme1 est un Entier*/	
			{
			 resultat.notreReel=obtenirArcCosinus(convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier));
			}
	
	libererStruct(terme1);	
	resultat.aDetruire=0;
	
	if (verifierErreur()==404)
		{
		printf("Erreur : %s\n",expliquerErreur(404));
		libererStruct(resultat);
		exit(1);
		}
	
	return resultat;
}

// La fonction sinus hyperbolique

typeRetourneParDollar calculerArcSinus(typeRetourneParDollar terme1)
{
	if (terme1.type==2)		/* terme1 est une Matrice*/  
		{exit(1);}
	else
		typeRetourneParDollar resultat;
		resultat.type=0;
		
		if (terme1.type==1) 	/* terme1 est un Rel*/
			{
			 resultat.notreReel=obtenirTangente(terme1.notreReel);
			}
		
		else			/* terme1 est un Entier*/	
			{
			 resultat.notreReel=obtenirTangente(convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier));
			}
	
	libererStruct(terme1);	
	resultat.aDetruire=0;
	
	if (verifierErreur()==403)
		{
		printf("Erreur : %s\n",expliquerErreur(403));
		libererStruct(resultat);
		exit(1);
		}
	
	return resultat;
}

// La fonction tangente hyperbolique

typeRetourneParDollar calculerArcTangente(typeRetourneParDollar terme1)
{
	if (terme1.type==2)		/* terme1 est une Matrice*/  
		{exit(1);}
	else
		typeRetourneParDollar resultat;
		resultat.type=0;
		
		if (terme1.type==1) 	/* terme1 est un Rel*/
			{
			 resultat.notreReel=obtenirArcTangente(terme1.notreReel);
			}
		
		else			/* terme1 est un Entier*/	
			{
			 resultat.notreReel=obtenirArcTangente(convertirUnEntierInfiniVersUnReelInfini(terme1.notreEntier));
			}
	
	libererStruct(terme1);	
	resultat.aDetruire=0;
	
	if (verifierErreur()==401)
		{
		printf("Erreur : %s\n",expliquerErreur(401));
		libererStruct(resultat);
		exit(1);
		}
	
	return resultat;
}



