  #include <stdlib.h>
  #include <string.h>		
  #include "Matrice.h"
  #include "Memoire.h"		
  #include "Error.h"
  #include "EntierInfini.h"		
  #include "ReelInfini.h"

  Matrice reconnaitreMatrice(char* );
  void calculerDimensionMatrice(char* ,int* ,int* );
  ReelInfini creerUnNombre(char*,int,int);

void calculerDimensionMatrice(char* notreChaine,int *hauteur,int *largeur){
      int compteurDeLignes; /*compteur de lignes*/
	int compteurDeColonnes; /*compteur d'elements*/
	int nombreDeCOlonnesDeLaLignePrecedente;
	int premiereIteration;
	int nouvelleLigne; /* 1 si dbut d'une nouvelle ligne, 0 sinon. Permet de ne pas tenir compte des espaces en dbut de ligne */
	int uneErreurSestProduite; /*1 s'il y a eu erreur, 0 sinon*/

	int indic; /*rsultat de l'appel de la fonction d'erreur*/
	int index; /*position dans la chaine*/
	
	compteurDeLignes=1;
	premiereIteration=0;
	index=1;
	uneErreurSestProduite=0;
	nouvelleLigne=1;
	
	while (notreChaine[index]!=']'){
			compteurDeColonnes=1;	
			while(notreChaine[index]!='|'){
				if (nouvelleLigne==1){
					while(notreChaine[index]==' ')
						index++;
					nouvelleLigne=0;
				}
				else{if((notreChaine[index]==' ')&&(notreChaine[index+1]!=' ')&&(notreChaine[index+1]!=']')&&(notreChaine[index+1]!='|'))
						compteurDeColonnes++;
				}
				index++;
			};

			nouvelleLigne=1;
			premiereIteration++;

			if (premiereIteration==1){
				nombreDeCOlonnesDeLaLignePrecedente=compteurDeColonnes;
			}
			else {
				if (nombreDeCOlonnesDeLaLignePrecedente!=compteurDeColonnes){
					uneErreurSestProduite=1;
					if(signalerErreur(601)==0){						
						printf("Erreur a l'appel de la fonction de la gestion d'erreur");
						exit(0);
					};
					*hauteur=0;
					*largeur=0;
					}
			};
			compteurDeLignes=compteurDeLignes+1;
			index++;
	};
	if(uneErreurSestProduite==0){
		*hauteur=compteurDeLignes;
		*largeur=compteurDeColonnes;
	}
}



Matrice reconnaitreMatrice(char* notreChaine){
	Matrice notreMatrice;
	int hauteur, largeur;
	int erreur;
	int indexLigne,indexColonne,indexChaine;
	int debutDUnNombre,finDUnNombre;
	ReelInfini element;

	debutDUnNombre=1;
	indexChaine=1;

	calculerDimensionMatrice(notreChaine,&hauteur,&largeur);
	erreur=verifierErreur();
	if (erreur!=0){
		expliquerErreur(erreur);
	}
	else{	notreMatrice=creerUneMatrice(hauteur,largeur);
		for(indexLigne=1;indexLigne<=hauteur;indexLigne++){
			for(indexColonne=1;indexColonne<=largeur;indexColonne++){
				debutDUnNombre=indexChaine;
				while(notreChaine[debutDUnNombre]==' ')
					debutDUnNombre++;
				finDUnNombre=debutDUnNombre;
				do{
					finDUnNombre++;
				}
				while((notreChaine[finDUnNombre]!=' ')&&(notreChaine[finDUnNombre]!='|')&&(notreChaine[finDUnNombre]!=']'));
				finDUnNombre--;
				element=creerUnNombre(notreChaine,debutDUnNombre,finDUnNombre);
				notreMatrice=fixerValeurDUnElement(notreMatrice,indexLigne,indexColonne,element);
				if (verifierErreur()!=0){
					expliquerErreur(erreur);
				}
				else{debutDUnNombre=finDUnNombre;
					while((notreChaine[indexChaine+1]==' ')||(notreChaine[indexChaine+1]=='|')||(notreChaine[indexChaine+1]==']')){
						debutDUnNombre++; 
					}
				}
				indexColonne++;
				if (indexColonne>largeur){
					indexLigne++;
					indexColonne=0;
				}
			}
		}
	}
}
ReelInfini creerUnNombre(char* notreChaine,int indiceDebut,int indiceFin){
	int estUnReel=0;
	int finPartieEntiere;
	int i=indiceDebut;
	char* partieEntiere;
	char* partieDecimale;
	char* nombreEntier;
	char signe='+' ;
	do {
		if (notreChaine[i]==','){
			estUnReel=1;
			finPartieEntiere=i-1;
		};
	}
	while((estUnReel==0)&&(i<indiceFin));

	if(notreChaine[indiceDebut]=='+'){
		indiceDebut=indiceDebut+1;}

	if(notreChaine[indiceDebut]=='-'){
		indiceDebut=indiceDebut+1;
		signe='-';}

		
	if(estUnReel==1){
		partieEntiere=malloc((finPartieEntiere-indiceDebut+1)*sizeof(char));
		for(i=0;i<=finPartieEntiere-indiceDebut;i++){
			partieEntiere[i]=notreChaine[i+indiceDebut];
		}
		
		partieDecimale=malloc((indiceFin-(finPartieEntiere+2)+1)*sizeof(char));
		for(i=0;i<=indiceFin-(finPartieEntiere+2);i++){
			partieDecimale[i]=notreChaine[i+finPartieEntiere+2];
		}

		return(creerUnReelInfiniAPartirDe(partieEntiere,partieDecimale,signe));
		free(partieEntiere);
		free(partieDecimale);
		partieEntiere=NULL;
		partieDecimale=NULL;
	}
	else {nombreEntier=malloc((indiceFin-indiceDebut+1)*sizeof(char));
		for(i=0;i<=indiceFin-indiceDebut;i++){
			nombreEntier[i]=notreChaine[i+indiceDebut];
		}
		return(convertirUnEntierInfiniVersUnReelInfini(creerUnEntierInfiniAPartirDe(nombreEntier,signe)));
		free(nombreEntier);
		nombreEntier=NULL;
	};
};
